package admin_common

import (
	"github.com/gin-gonic/gin"
	"go-micro.dev/v4/client"
	"sghgogs.com/sghblog/authorization-client/api/admin_common"
	"sghgogs.com/sghblog/authorization-client/utils"
	"sghgogs.com/sghblog/authorization-client/utils/baseservice"
	pb "sghgogs.com/sghblog/authorization-service/proto"
)

type AdminCommon struct {
	*baseservice.BaseService
}

func NewAdminCommonRouter(namespace string, client client.Client) *AdminCommon {
	return &AdminCommon{
		BaseService: &baseservice.BaseService{
			Namespace: namespace,
			Client:    client,
		},
	}
}
func (svc *AdminCommon) RegisterRoutes(r *gin.Engine) {
	api := admin_common.ApiAdminCommon{}
	commonService := pb.NewCommonService(svc.Namespace, svc.Client)
	api.Service = commonService
	svc.registerAdminCommonRoutes(r, "/v1/api", &api)
}

func (svc *AdminCommon) registerAdminCommonRoutes(r *gin.Engine, path string, api *admin_common.ApiAdminCommon) {
	v1 := r.Group(path)
	{
		v1.POST("/admin/login", api.Login)
		v1.POST("/admin/logout", api.Logout)
		v1.GET("/admin/profile", utils.TokenAuthMiddleware(), api.Profile)
	}
}
